;==============================================================================
.model small, c
.386
include support.asm
.stack
;==============================================================================
.data
    myArray dw 0,1,2,3,4,5,6,7
.code
;==============================================================================
.startup
;==============================================================================
    ;---------------------------------------------------------------------
    ; For indirect memory operands with 16-bit registers, the operand can
    ; include a base register (BX or BP) or an index register (SI or DI),
    ; or one of each, and one or more displacements.
    ;
    ; Here the element offset is encoded as a displacement.
    ;---------------------------------------------------------------------

    mov bx, OFFSET myArray
  @@:
    mov ax, [bx+8]                    ; load element 4 into AX
    print word$(ax),13,10

    ;--------------------------------------------
    ; Here myArray and 8 are both displacements.
    ;--------------------------------------------

    xor bx, bx
  @@:
    mov ax, myArray[bx+8]             ; load element 4 into AX
    print word$(ax),13,10

    ;------------------------------------------
    ; Here the element offset is stored in SI.
    ;------------------------------------------

    mov bx, OFFSET myArray
    mov si, 8
  @@:
    mov ax, [bx+si]                   ; load element 4 into AX
    print word$(ax),13,10

    ;------------------------------------------------------------------
    ; To use the index (or base) register to index anything other than
    ; a BYTE array, you must scale the index by the size of the array
    ; elements in a separate instruction, before it is used to address
    ; the array.
    ;------------------------------------------------------------------

    mov si, 4                         ; load element index
    shl si, 1                         ; scale the index by 2
    mov ax, myArray[si]               ; load element 4 into AX
    print word$(ax),13,10

    ;---------------------------------------------------------------------
    ; For indirect memory operands with 32-bit registers, any general-
    ; purpose register can be used as the base register and any general-
    ; purpose register other than ESP as the index register. The operand
    ; can include a scale factor (1, 2, 4, or 8) on the index register,
    ; and one or more displacements.
    ;---------------------------------------------------------------------

    mov edx, OFFSET myArray
    mov ecx, 3
    mov ax, [edx+ecx*2+2]             ; load element 4 into AX
    print word$(ax),13,10

    mov ecx, 4
    mov ax, myArray[ecx*2]            ; load element 4 into AX
    print word$(ax),13,10

    call waitkey

;==============================================================================
.exit
end
